#ifndef NEZ_FILE
#define NEZ_FILE

#include <windows.h>
#include "common/nsfsdk/nsfsdk.h"
#include "common/zlib/nez.h"
#include "kmpsdk/kmp_pi.h"

class KbNEZFile
{
private:
    HNSF hNSF;
public:
    BOOL __fastcall Open(const char *cszFileName, SOUNDINFO *pInfo);
    void __fastcall Close(void);
    DWORD __fastcall SetPosition(DWORD dwPos);
    DWORD __fastcall Render(BYTE *Buffer, DWORD dwSize);
    KbNEZFile(void);
    ~KbNEZFile(void);
};

#endif